From 58011e58080baaf6bdfe3aee2b88f570406b3122 Mon Sep 17 00:00:00 2001
From: Shaily <shaily15297@yahoo.com>
Date: Oct 22 2017 11:08:16 +0000
Subject: [PATCH 995/1001] Add markdown rendering capability to Sticky Note widget


---

diff --git a/hubs/widgets/sticky/__init__.py b/hubs/widgets/sticky/__init__.py
index 13c6af3..7399bff 100644
--- a/hubs/widgets/sticky/__init__.py
+++ b/hubs/widgets/sticky/__init__.py
@@ -2,8 +2,11 @@ from __future__ import unicode_literals
 
 from hubs.widgets import validators
 from hubs.widgets.base import Widget
+from hubs.widgets.caching import CachedFunction
 from hubs.widgets.view import RootWidgetView
 
+from markdown import markdown
+
 
 class Sticky(Widget):
 
@@ -11,9 +14,12 @@ class Sticky(Widget):
     label = "Sticky Note"
     position = "both"
     display_css = "card-info"
+    is_large = True
     parameters = [
         dict(
             name="text",
+            render_tag="textarea",
+            render_attributes={"rows": "30"},
             label="Text",
             default="Lorem ipsum dolor...",
             validator=validators.Text,
@@ -24,7 +30,18 @@ class Sticky(Widget):
 class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
-        # TODO -- render with markdown
+        md = ParseMarkdown(instance)
         return dict(
-            text=instance.config["text"],
-            )
+            text=md()
+        )
+
+
+class ParseMarkdown(CachedFunction):
+
+    def execute(self):
+        text = self.instance.config["text"]
+        return markdown(text, extensions=['markdown.extensions.extra',
+                                          'markdown.extensions.sane_lists'])
+
+    def should_invalidate(self, message):
+        return False
